# Proto Plus for Python

> Beautiful, Pythonic protocol buffers.

This library provides a clean, readable, straightforward pattern for declaring messages in protocol buffers. It provides a wrapper around the official implementation, so that using messages feels natural while retaining the power and flexibility of protocol buffers.

## Installing

Install this library using `pip`:

    $ pip install proto-plus

This library carries a dependency on the official implementation (protobuf), which may install a C component.

## Table of Contents

- Messages
  - Declaring messages
  - Usage
  - Assigning to Fields
  - Enums
  - Serialization
- Fields
  - Repeated fields
  - Map fields
  - Oneofs (mutually-exclusive fields)
  - Optional fields
- Type Marshaling
  - Well-known types
  - Wrapper types
- Status
  - Features and Limitations
  - Upcoming work
- Reference
  - Message and Field
  - Marshal
  - Datetime Helpers